/*

Licensed under the GNU AFFERO GENERAL PUBLIC LICENSE Version 3 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    https://www.gnu.org/licenses/agpl-3.0.html

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package settings

import (
	"k8s.libre.sh/application/settings/parameters"
)

type Config interface {
	GetParameters() *parameters.Parameters
	SetParameters(*parameters.Parameters)
	//	InitRandValues()
	//	InitTemplateValues(map[string]string) error
	//	InitTemplateValues(map[string]interface{}) error
	//	InitValuesFrom(c client.Client) error
	SetSources(sources []Source)
	GetSources() (sources []Source)
}

func MergeSettings(src, dest Config) Config {

	if dest == nil {
		dest = src
	} else {
		dest.SetSources(append(dest.GetSources(), src.GetSources()...))

		params := *dest.GetParameters()

		if params == nil {
			params = *src.GetParameters()
		} else {
			for _, p := range *src.GetParameters() {
				params = append(params, p)
			}
		}
		dest.SetParameters(&params)
	}

	return dest
}
