package parameters_test

import (
	"context"
	"testing"

	. "github.com/onsi/ginkgo"
	. "github.com/onsi/gomega"
	"k8s.io/client-go/rest"
	"sigs.k8s.io/controller-runtime/pkg/client"
	"sigs.k8s.io/controller-runtime/pkg/envtest"
)

func TestParameters(t *testing.T) {
	RegisterFailHandler(Fail)
	RunSpecs(t, "Parameters Suite")
}

var t *envtest.Environment
var cfg *rest.Config
var c client.Client
var ctx context.Context

var _ = BeforeSuite(func() {
	var err error

	t = &envtest.Environment{
		//	CRDDirectoryPaths: []string{filepath.Join("..", "config", "crd", "bases")},
	}

	cfg, err = t.Start()
	Expect(err).NotTo(HaveOccurred())

	c, err = client.New(cfg, client.Options{})
	Expect(err).NotTo(HaveOccurred())

})

var _ = AfterSuite(func() {
	Expect(t.Stop()).To(Succeed())
})
